/*
 * Nenad Taskovic 5/93
 * e-mail: neyt@fon.bg.ac.yu
 * www: http://fon.fon.bg.ac.yu/~neyt/
 */

#include "hrs.h"
#include <string.h>

Lista *promenljive, *naredbe, *labele;

int main (int argc, char *argv[])
{
	FILE *dat;
   int verbose = 0;

   if (argc >= 2) {
      dat = fopen(argv[1], "rt");
      if (dat == NULL) {
         fprintf(stderr, "Greska: Datoteka `%s' ne postoji.\n", argv[1]);
         fprintf(stderr, "Nacin koriscenja:\nhrs <datoteka sa programom> [-v]\n");
         return 1;
      }
   } else {
      fprintf(stderr, "Greska: Nedostaje datoteka sa programom.\n");
      fprintf(stderr, "Nacin koriscenja:\nhrs <datoteka sa programom> [-v]\n");
      return 2;
   }
   if (argc >= 3)
      if (strcmp(argv[2], "-v") == 0)
         verbose = 1;
      else {
         fprintf(stderr, "Greska: Nepoznata opcija `%s'.\n", argv[2]);
         fprintf(stderr, "Nacin koriscenja:\nhrs <datoteka sa programom> [-v]\n");
         return 3;
      }
	promenljive = kreiraj_listu(sizeof(Promenljiva));
	naredbe = kreiraj_listu(sizeof(Naredba));
	labele = kreiraj_listu(sizeof(Labela));

	if (citaj_deklaracije(dat)) {
	   if (parsiraj(dat)) {
      	na_pocetak(promenljive);
         if (verbose) {
      	   while (!kraj_liste(promenljive)) {
      		   Promenljiva *p;
      		   p = (Promenljiva *)podatak(promenljive);
      		   printf("%s(%d)\n", p->naziv, p->duzina);
               napred(promenljive);
      	   }
            na_pocetak(naredbe);
      	   while (!kraj_liste(naredbe)) {
      		   Naredba *n;
      		   n = (Naredba *)podatak(naredbe);
      		   printf("%s", stringovi_instrukcija[n->kod_naredbe]);
               if (!naredba_skoka[n->kod_naredbe]) {
                  int i;
                  for (i=0; i<br_arg_instr[n->kod_naredbe]; i++)
                     printf(" %s", ((Promenljiva *)n->arg[i])->naziv);
               } else
                  printf(" na labelu %s", ((Labela *)n->arg[0])->naziv);
               printf("\n");
               napred(naredbe);
      	   }
            na_pocetak(labele);
      	   while (!kraj_liste(labele)) {
      		   Labela *l;
               Naredba *n;
      		   l = (Labela *)podatak(labele);
               n = (Naredba *) l->nar_adr->podatak;
      		   printf("%s: %s\n", l->naziv, stringovi_instrukcija[n->kod_naredbe]);
               napred(labele);
      	   }
         }
      }
   }
   else {
      printf("Deklaracije nisu sintaksno ispravne.\n");
      return 4;
   }

   izvrsi_program();

   unisti_listu(promenljive);
   unisti_listu(labele);
   unisti_listu(naredbe);

   fclose(dat);

	return 0;
}

