/*
 * Nenad Taskovic 5/93
 * e-mail: neyt@fon.bg.ac.yu
 * www: http://fon.fon.bg.ac.yu/~neyt/
 */

#include "lista.h"
#include <stdio.h>

#define CLR 0
#define ADD 1
#define SUB 2
#define MUL 3
#define DIV 4
#define MOV 5
#define INC 6
#define DEC 7
#define TST 8
#define CMP 9
#define JMP 10
#define BLT 11
#define BLE 12
#define BEQ 13
#define BGE 14
#define BGT 15
#define BNE 16
#define HALT 17
#define SETXR 18
#define INCXR 19

#define IDENT_LEN 32

typedef struct {
   char naziv[IDENT_LEN];
   int duzina;
   int *vrednost;
} Promenljiva;

typedef struct {
   int kod_naredbe;
   void *arg[2];
} Naredba;

typedef struct {
   char naziv[IDENT_LEN];
   Cvor *nar_adr;
} Labela;

int citaj_deklaracije (FILE *);

int identifikator (FILE *, char *);

int naredba (const char *);

Labela *nadji_labelu (const char *naziv);

int analiziraj_naredbu (const char *labela, int opcod,
                        const char arg[2][IDENT_LEN], int br_arg);

int citaj_naredbu (FILE *);

int parsiraj (FILE *);

typedef Cvor* (*Nar_fun) (void*, void*) ;
   /** tip funkcije koja se koristi za simulaciju izvrsenja naredbe */

Cvor *clr (void*, void*);
Cvor *add (void*, void*);
Cvor *sub (void*, void*);
Cvor *mul (void*, void*);
Cvor *div (void*, void*);
Cvor *mov (void*, void*);
Cvor *inc (void*, void*);
Cvor *dec (void*, void*);
Cvor *tst (void*, void*);
Cvor *cmp (void*, void*);
Cvor *jmp (void*, void*);
Cvor *blt (void*, void*);
Cvor *ble (void*, void*);
Cvor *beq (void*, void*);
Cvor *bge (void*, void*);
Cvor *bgt (void*, void*);
Cvor *bne (void*, void*);
Cvor *halt (void*, void*);
Cvor *setxr (void*, void*);
Cvor *incxr (void*, void*);

void izvrsi_program (void);

static Nar_fun nar_fun[20] = {clr, add, sub, mul, div, mov, inc, dec, tst,
                              cmp, jmp, blt, ble, beq, bge, bgt, bne, halt,
                              setxr, incxr};


extern Lista *promenljive, *naredbe, *labele;

static char *stringovi_instrukcija[] = {"CLR", "ADD", "SUB", "MUL", "DIV",
     "MOV", "INC", "DEC", "TST", "CMP", "JMP", "BLT", "BLE", "BEQ", "BGE",
     "BGT", "BNE", "HALT", "SETXR", "INCXR"
};

static char naredba_skoka[20] = {0,0,0,0,0,0,0,0,0,0,1,1,1,1,1,1,1,0,0,0};

static char br_arg_instr[20] = {1, 2, 2, 2, 2, 2, 1, 1, 1, 2, 1, 1, 1, 1, 1, 1,
	  1, 0, 0, 0
};

