/*
 * Nenad Taskovic 5/93
 * e-mail: neyt@fon.bg.ac.yu
 * www: http://fon.fon.bg.ac.yu/~neyt/
 */

#include "lista.h"
#include <stdlib.h>
#include <string.h>

Lista *kreiraj_listu (int duzpod)
{
   Lista *lista;
   Cvor *dummy;

   lista = (Lista *) malloc(sizeof(Lista));
   lista->duzpod = duzpod;
   dummy = (Cvor *) malloc(sizeof(Cvor));
   dummy->pret = dummy;
   dummy->sled = dummy;
   dummy->podatak = 0;
   lista->glava = dummy;

   return lista;
}

Cvor *alociraj_cvor (Lista *lista, void *podatak)
{
   Cvor *cvor;

   cvor = (Cvor *) malloc(sizeof(Cvor));
   cvor->podatak = malloc(lista->duzpod);
   memcpy(cvor->podatak, podatak, lista->duzpod);

   return cvor;
}

void dealociraj_cvor (Cvor *cvor)
{
   free(cvor->podatak);
   free(cvor);
}

void unisti_listu (Lista *lista)
{
   Cvor *cvor, *tmp;

   cvor = lista->glava->sled;
   lista->glava->sled = NULL;
   while (cvor) {
      tmp = cvor;
      cvor = cvor->sled;
      dealociraj_cvor(tmp);
   }
   free(lista);
}

void ubaci_na_pocetak (Lista *lista, void *podatak)
{
   Cvor *cvor;

   cvor = alociraj_cvor(lista, podatak);
   cvor->pret = lista->glava;
   cvor->sled = lista->glava->sled;
   cvor->sled->pret = cvor;
   lista->glava->sled = cvor;
   lista->tek = cvor;
}

void ubaci_na_kraj (Lista *lista, void *podatak)
{
   Cvor *cvor;

   cvor = alociraj_cvor(lista, podatak);
   cvor->sled = lista->glava;
   cvor->pret = lista->glava->pret;
   cvor->pret->sled = cvor;
   lista->glava->pret = cvor;
   lista->tek = cvor;
}

void *podatak (Lista *lista)
{
   return lista->tek->podatak;
}

Cvor *tekuci (Lista *lista)
{
   return lista->tek;
}

void na_pocetak (Lista *lista)
{
   lista->tek = lista->glava->sled;
}

void napred (Lista *lista)
{
   lista->tek = lista->tek->sled;
}

void na_kraj (Lista *lista)
{
   lista->tek = lista->glava->pret;
}

void nazad (Lista *lista)
{
   lista->tek = lista->tek->pret;
}

int kraj_liste (Lista *lista)
{
   return (lista->tek == lista->glava);
}

void izbaci_iz_liste (Lista *lista)
{
   lista->tek->pret->sled = lista->tek->sled;
   lista->tek->sled->pret = lista->tek->pret;
   dealociraj_cvor(lista->tek);
}

void izbaci_sa_pocetka (Lista *lista)
{
   Cvor *cvor;

   cvor = lista->glava->sled;
   lista->glava->sled = cvor->sled;
   cvor->sled->pret = lista->glava;
   dealociraj_cvor(cvor);
}

void izbaci_sa_kraja (Lista *lista)
{
   Cvor *cvor;

   cvor = lista->glava->pret;
   lista->glava->pret = cvor->pret;
   cvor->pret->sled = lista->glava;
   dealociraj_cvor(cvor);
}

void postavi_tekuci(Lista *lista, Cvor *cvor)
{
   lista->tek = cvor;
}
