/*
 * Nenad Taskovic 5/93
 * e-mail: neyt@fon.bg.ac.yu
 * www: http://fon.fon.bg.ac.yu/~neyt/
 */

#include "hrs.h"
#include <string.h>
#include <malloc.h>

int citaj_deklaracije (FILE *dat)
{
	int duzina, postoji;
	char naziv[IDENT_LEN];
	Promenljiva prom;

	while (fscanf(dat, " %[0-9A-Za-z_] ( %d )", naziv, &duzina) == 2) {
		na_pocetak(promenljive);
		postoji = 0;
		while (!kraj_liste(promenljive)) {
			if (stricmp(naziv,((Promenljiva *)podatak(promenljive))->naziv) == 0)
				postoji = 1;
         napred(promenljive);
		}

		if (!postoji) {
			strcpy(prom.naziv, naziv);
			prom.duzina = duzina;
			prom.vrednost = (int *) calloc(duzina, sizeof(int));
			ubaci_na_kraj(promenljive, &prom);
      }
   }

   return (fgetc(dat) == '@');
}

int identifikator (FILE *dat, char *ident)
{
   return (fscanf(dat, "%[0-9A-Za-z]", ident) == 1);
}

int naredba (const char *ident)
{
   int i = 0;

   while ((i < 20) && stricmp(ident, stringovi_instrukcija[i]))
	  i++;
   if (i < 20)
     return i+1;
   else
     return 0;
}

Labela *nadji_labelu (const char *naziv)
{
   na_pocetak(labele);
   while (!kraj_liste(labele) &&
         stricmp(naziv, ((Labela *)podatak(labele))->naziv) != 0)
      napred(labele);

   return (kraj_liste(labele) ? NULL : (Labela *)podatak(labele));
}

int analiziraj_naredbu (const char *labela, int opcod,
                        const char arg[2][IDENT_LEN], int br_arg)
{
   Naredba nar;
   Labela lab;
   Promenljiva prom;
   if (br_arg != br_arg_instr[opcod-1]) {
      printf(" %s: %s %s, %s\n", labela, stringovi_instrukcija[opcod-1], arg[0], arg[1]);
      printf("Naredba %s treba da ima %d argumenata.\n",
	     stringovi_instrukcija[opcod-1], br_arg_instr[opcod-1]);

      return 0;
   }
	else {
      /* ubacivanje naredbe */
      nar.kod_naredbe = opcod - 1;

      /* ubacivanje promenljive */
      if (!naredba_skoka[opcod - 1]) {
         int i;
         int postoji;
         for (i=0; i<br_arg_instr[opcod - 1]; i++) {
            postoji = 0;
   		   na_pocetak(promenljive);
		      while (!kraj_liste(promenljive)) {
			      if (stricmp(arg[i],((Promenljiva *)podatak(promenljive))->naziv) == 0) {
				      postoji = 1;
                  nar.arg[i] = podatak(promenljive);
               }
               napred(promenljive);
		      }
		      if (!postoji) {
	   		   strcpy(prom.naziv, arg[i]);
		   	   prom.duzina = 1;
			      prom.vrednost = (int *) calloc(1, sizeof(int));
			      ubaci_na_kraj(promenljive, &prom);
               nar.arg[i] = podatak(promenljive);
            }
         }
      } else {
         Labela *l;
         if ( (l=nadji_labelu(arg[0])) == NULL ) {
            strcpy(lab.naziv, arg[0]);
            lab.nar_adr = NULL;
            ubaci_na_kraj(labele, &lab);
            l = (Labela *) podatak(labele);
         }
         nar.arg[0] = l;
      }
      ubaci_na_kraj(naredbe, &nar);

      /* ubacivanje labele */
      if (labela[0]) {
         Labela *l;
         if ( (l=nadji_labelu(labela)) == NULL ) {
            strcpy(lab.naziv, labela);
            /*lab.nar_adr = tekuci(naredbe);*/
            ubaci_na_kraj(labele, &lab);
            l = (Labela *) podatak(labele);
         } else
            if (l->nar_adr != NULL)
               printf("Upozorenje: Labela `%s' se javlja vise puta.\nPodrazumeva se poslednje javljanje.\n",
                      l->naziv);
         l->nar_adr = tekuci(naredbe);
      }

      return 1;
   }
}

int citaj_naredbu (FILE *dat)
/* Funkcija radi na principu konacnog automata. Promenljiva `s' oznacava stanja.
 * s = 4 - prihvatanje jedne naredbe; s = 8 - beskonacno neprihvatajuce stanje;
 * s = 9 - prihvacena naredba i kraj programa; s = 10 kraj programa
 * s = 0 - pocetno stanje.
 */
{
   int s = 0;
   char labela[IDENT_LEN];
   char arg[2][IDENT_LEN] = {"",""};
   char ident[IDENT_LEN];
   int opcod, br_arg = 0;
   int ch;

   labela[0] = 0;

   while (s != 4 && s != 8 && s!=9 && s!=10) {
      while (strchr(" \t", ch=fgetc(dat))); /* unistavanje blanko znakova */
      ungetc(ch, dat); /* vracanje prvog ne-blanko znaka u datoteku */
      switch (s) {
       case 0:
	      ch = fgetc(dat);
	      if (ch == EOF)
	         s = 10;
	      else {
	         ungetc(ch, dat);
	         if (identifikator(dat, ident)) {
	            if ((opcod = naredba(ident)) != 0) {
		            s = 3;
	            }
	            else
		            s = 1;
		      }
	    else
	      s = 8;
	 }
	 break;
       case 1:
	 if (fgetc(dat) == ':') {
	    strcpy(labela, ident);
	    s = 2;
	 }
	 else
	   s = 8;
	 break;
       case 2:
	 if (identifikator(dat, ident)) {
	    if ((opcod = naredba(ident)) != 0) {
	       s = 3;
		 }
	    else
	      s = 8;
	 }
	 else
	   s = 8;
	 break;
       case 3:
	 ch = fgetc(dat);
	 if (ch == '\n' || ch == EOF)
	   s = 4;
	 else {
	    ungetc(ch, dat);
	    if (identifikator(dat, ident)) {
	       strcpy(arg[0], ident);
	       br_arg = 1;
	       s = 5;
		 }
	    else
	      s = 8;
	 }
	 break;
       case 5:
	 ch = fgetc(dat);
	 if (ch == ',')
	   s = 6;
	 else if (ch == '\n')
      s = 4;
	 else if (ch == EOF)
	   s = 9;
	 else
	   s = 8;
	 break;
       case 6:
	 if (identifikator(dat, ident)) {
	    strcpy(arg[1], ident);
		 br_arg = 2;
	    s = 7;
	 }
	 else
	   s = 8;
	 break;
       case 7:
	 ch = fgetc(dat);
	 if (ch == '\n')
      s = 4;
	 else if (ch == EOF)
	   s = 9;
	 else
	   s = 8;
	 break;
      }
   }
   if (s == 4 || s == 9 || s == 10)
      if (s == 10)
         return 2;
      else if (s == 9)
	      return (analiziraj_naredbu(labela, opcod, arg, br_arg)*2);
      else
         return (analiziraj_naredbu(labela, opcod, arg, br_arg));
	else
     return (0);
}

int parsiraj (FILE *dat)
{
   int ok=1;
   int ch;
   while (strchr(" \t\n", ch=fgetc(dat))); /* unistavanje blanko znakova */
   ungetc(ch, dat); /* vracanje prvog ne-blanko znaka u datoteku */
   while (ok==1) {
      ok = citaj_naredbu(dat);
   }
   if (ok==2) {
      fprintf(stdout, "Program je ispravan.\n");
      return 1;
   } else {
      fprintf(stdout, "Program je pogresno napisan.\n");
      return 0;
   }
}
